#include "usb.h"
#include "utils.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

libusb_device* skillerctl_find_device(libusb_device **devices, size_t count)
{   
    libusb_device *device;
    struct libusb_device_descriptor descriptor;

    for (unsigned i = 0; i < count; i++) {
        device = devices[i];

        libusb_get_device_descriptor(device, &descriptor);
        if (descriptor.idVendor == SK_VID && descriptor.idProduct == SK_PID) {
            return device;
        }
    }

    return NULL;
}

void skillerctl_send_command(libusb_device_handle *handle, skillerctl_packet_t *packet)
{
    // buffer for storing packed packet
    uint8_t buffer[SK_PACKET_SIZE];
    int     length;

    skillerctl_pack(packet, buffer);
    printf("Sending packet to keyboard: \n");
    hexdump(buffer, SK_PACKET_SIZE);

    libusb_control_transfer(handle, 0x21, 9, 0x0204, 0x0001, buffer, SK_PACKET_SIZE, 250);
    libusb_interrupt_transfer(handle, SK_PORT_STATE, buffer, sizeof(buffer), &length, 250);

    printf("State from keyboard: \n");
    hexdump(buffer, SK_PACKET_SIZE);

    // we need to pretend that we're doing important stuff
    usleep(100000);
}
